<?php

require_once dirname(__FILE__) . '/../../../SEI.php';

/**
 * Repositrio para mtodos para Tipo de Documento Mapeados pelo mdulo PEN
 * 
 * @autor Join Tecnologia
 */
class TipoDocMapRN extends InfraRN {

    protected function inicializarObjInfraIBanco() {
        return BancoSEI::getInstance();
    }

    /**
     * Retorna um array de chave => valor, onde a chave  a ID e o valor  a descrio
     * do registro no banco de dados
     * 
     * @param bool $bolRemoverUtilizados remover os que j tem alguma relao
     * @param int $dblCodigoEspecie Cdigo do Tipo de Documento. S funciona em
     * conjunto com o primeiro paramtro
     * @return array
     */
    public function listarParesEspecie($arrNumCodigoEspecie = array()) {

        try {

            $objInfraIBanco = $this->inicializarObjInfraIBanco();
            $objGenericoBD = new GenericoBD($objInfraIBanco);

            $objEspecieDocumentalDTO = new EspecieDocumentalDTO();
            $objEspecieDocumentalDTO->retDblIdEspecie();
            $objEspecieDocumentalDTO->retStrNomeEspecie();
            $objEspecieDocumentalDTO->setOrdStrNomeEspecie(InfraDTO::$TIPO_ORDENACAO_ASC);

            if (!empty($arrNumCodigoEspecie)) {

                $objEspecieDocumentalDTO->setDblIdEspecie($arrNumCodigoEspecie, InfraDTO::$OPER_NOT_IN);
            }

            $arrEspecieDocumentalDTO = $objGenericoBD->listar($objEspecieDocumentalDTO);

            $arrRetorno = array();

            if (!empty($arrEspecieDocumentalDTO)) {

                foreach ($arrEspecieDocumentalDTO as $objEspecieDocumentalDTO) {

                    $strChave = strval($objEspecieDocumentalDTO->getDblIdEspecie());
                    $strValor = InfraString::formatarXML($objEspecieDocumentalDTO->getStrNomeEspecie());

                    $arrRetorno[$strChave] = $strValor;
                }
            }
            return $arrRetorno;
        } catch (InfraException $e) {
            
        }
    }
    
        /**
     * Retorna um array de chave => valor, onde a chave  a ID e o valor  a descrio
     * do registro no banco de dados.
     * Utilizado na View, ento processa as exception na pgina de erro
     * 
     * @param bool $bolRemoverUtilizados remover os que j tem alguma relao
     * @param int $dblIdSerie Cdigo selecionado da Espcie Documental. 
     * S funciona em conjunto com o primeiro paramtro
     * @return array
     */
    public function listarParesSerie($arrNumIdSerie = array(), $bolListarTodos = false){
         
        try {
            $arrRetorno = array();
            $objInfraIBanco = $this->inicializarObjInfraIBanco();

            $objSerieDTO = new SerieDTO();
            $objSerieDTO->retNumIdSerie();
            $objSerieDTO->retStrNome();
            
            if($bolListarTodos === false) {
                $objSerieDTO->setStrStaAplicabilidade('I', InfraDTO::$OPER_DIFERENTE);
            }
            $objSerieDTO->setOrdStrNome(InfraDTO::$TIPO_ORDENACAO_ASC);

            if(!empty($arrNumIdSerie)) {

                $objSerieDTO->setNumIdSerie($arrNumIdSerie, InfraDTO::$OPER_NOT_IN);
            } 

            $objGenericoBD = new GenericoBD($objInfraIBanco);
            $arrObjSerieDTO = $objGenericoBD->listar($objSerieDTO);
                        
            if(!empty($arrObjSerieDTO)) {
                
                foreach($arrObjSerieDTO as $objSerieDTO) {

                    $strChave = strval($objSerieDTO->getNumIdSerie());
                    $strValor = InfraString::formatarXML($objSerieDTO->getStrNome());

                    $arrRetorno[$strChave] = $strValor;
                }            
            } 
            return $arrRetorno;
        
        }
        catch (InfraException $e) {
            
            PaginaSEI::getInstance()->processarExcecao($e);
        }
    } 

}
